<?php

declare(strict_types=1);

namespace Drupal\permissions_repository\Service;

/**
 */
interface PermissionsRepositoryInterface {
  public function addPermission(string $provider, array $permission): void;
  public function addSection(string $provider, array $section): void;
  public function setMain(string $provider, array $main): void;
  public function sortAll(): void;
  public function getProviders(): array;
  public function getAllPermissions(PermissionsRepositoryReturnStyle $style = PermissionsRepositoryReturnStyle::SectionArray): array;
  public function getProviderData(string $provider, PermissionsRepositoryReturnStyle $style = PermissionsRepositoryReturnStyle::SectionArray): array;
  public function getAllData(PermissionsRepositoryReturnStyle $style = PermissionsRepositoryReturnStyle::SectionArray): array;
}
